/**************************************************************************************
 Copyright (c) 2002 The UbixOS Project
 All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions, the following disclaimer and the list of authors.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions, the following disclaimer and the list of authors
in the documentation and/or other materials provided with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id: main.c,v 2.41 2003/05/07 05:03:37 reddawg Exp $

**************************************************************************************/

//Cleaned Up Here
#include <sys/gdt.h>
#include <sys/idt.h>
#include <sys/video.h>
#include <sys/drives.h>
#include <ubixfs/ubixfs.h>
#include <vmm/memory.h>
#include <vmm/paging.h>
#include <isa/8259.h>
#include <isa/atkbd.h>
#include <isa/fdc.h>
#include <isa/pit.h>
#include <pci/pci.h>
#include <pci/hd.h>
#include <pci/lnc.h>
#include <ubixos/schedule.h>
#include <ubixos/exec.h>
#include <ubixos/idlethread.h>
#include <ubixos/vitals.h>
#include <ubixos/version.h>
#include <ubixos/mount.h>
#include <ubixos/fs.h>
#include <sde/sde.h>
#include <lib/kmalloc.h>
#include <devfs/devfs.h>
#include <ld/ld.h>

//Quick Desc For main()
int main();

/************************************************************************

Function: General Descriptor Table
Description: This Is Where The General Descriptor Table Is Defined The
             Table Has 6 Entries They Are As Follows -
             0x00) Dummy Entry
             0x08) Ring 0 Code Segment
             0x10) Ring 0 Data Segment
             0x18) LDT Entry
             0x20) TSS Entry For Stack Faults
             0x28) TSS For Task Switch
             0x30) Ring 3 Code Segment
             0x38) Ring 3 Data Segment
             0x40) TSS For GPF
Notes:

02/17/03 - I Will Have To Add Data/Code Segments For Rings 1,2,3

************************************************************************/
descriptorTable(GDT,10) {
  {dummy:0},
  standardDescriptor(0x0, 0xFFFFF, (dCode + dRead + dBig + dBiglim)),
  standardDescriptor(0x0, 0xFFFFF, (dData + dWrite + dBig + dBiglim)),
  standardDescriptor(0x0, 0xFFFFF, (dLdt)),
  standardDescriptor(0x4000,   (sizeof(struct tssStruct)-8192), (dTss)),
  standardDescriptor(0x100000, sizeof(struct tssStruct), (dTss)),
  standardDescriptor(0x0, 0xFFFFF, (dCode + dWrite + dBig + dBiglim + dDpl3)),  
  standardDescriptor(0x0, 0xFFFFF, (dData + dWrite + dBig + dBiglim + dDpl3)),
  standardDescriptor(0x4200,   (sizeof(struct tssStruct)-8192), (dTss)),
  };
struct { 
  unsigned short limit __attribute__ ((packed));
  union descriptorTableunion *gdt __attribute__ ((packed));
  } loadGdt = { (10 * sizeof(union descriptorTableunion) - 1), GDT };

/************************************************************************

Function: _start();
Description: This Is The Main Entry Point For The Kernel We Just Re-Setup
             The GDT Here And Set All The Default Register Values

Notes:

02/17/03 - I'm Unhappy With The Infinite Loop I Decided To Do If The Call
           To Main Returns I Think I Shall Change It To A Kernel Panic
           At A Later Date Then Reboot The Machine

************************************************************************/  
void _start() {
  asm("cli");
  asm(
    "mov %cr0,%eax        \n"
    "and $0xFFFFFFFE,%eax \n"
    "mov %eax,%cr0        \n"
    "or $0x1,%eax         \n"
    "mov %eax,%cr0        \n"
    "lgdtl (loadGdt)   \n"
    "movw $0x10,%ax    \n"
    "movw %ax,%ds      \n"
    "movw %ax,%es      \n"
    "movw %ax,%fs      \n"
    "movw %ax,%gs      \n"
    "movw %ax,%ss      \n"
    "movl $0xFFFF,%esp \n"
    "mov $0x18,%ax     \n" //Set up dummy LDT
    "lldt %ax          \n"
    "mov $0x28,%ax     \n" // Set up dummy TSS
    "ltr %ax           \n" // Loads dummy TSS
    );
  main(); //Start Of Kernel Functionality
  while(1);
  }

/************************************************************************

Function: int main();
Description: This Is The Main Kernel Function Does All The Initialization
             Then Starts The INIT Program Which Will Take Over
Notes:

07/30/02 - I'm Considering Making The Kernel Fork Then Execute INIT
           However It Seems To Be Pretty Stable As Is

02/17/03 - Still Not Forking From Here Still Does All The Inits I'm
           Going To Work Hard At Making It a Bit More Organized           

************************************************************************/
int main() {
  initMmap();                      // Initialize Memory Map
  initPagingSystem();              // Initialize Paging System
  initVitals();                    // Initialize Vitals Tracking
  init8259();                      // Initialize PIC
  initIdt();                       // Initialize IDT
  enableUbixFS();                  // Initialize File System
  enableDevFS();                   // Initialize Device File System
  initPci();                       // Initialize PCI Subsystem
  //initLNC();                       // Initialize LNC
  initFloppy();                    // Initialize Floppy Controller
  //initHardDisk();                  // Iintialize Hard Drives
  mount(0x0,0x1,0x0,"sys","rw");   // Mount System File System
  mount(0x0,0x0,0x0,"home","rw");  // Mount The Root File System
  initKeyboard();                  // Initialize Keyboard
  initScheduler();                 // Initialize Scheduler
  //initPIT(1000);                   // Initialize Pit (Doesnt Work In Bochs)
  //Make Nodes
  devFsMkNod("drive1",'b',0x1,0x0);
  loadLibrary("libc.so@sys");
  outputVersion();          // Display Version Info
  execThread(idleThread,(uInt32)(kmalloc(4096,-2)+4095),"Idle Thread");
  execFile("init@sys");
  //execThread(sdeThread,(uInt32)(kmalloc(4096,-2)+4095),"SDE Thread");
  kprintf("Free Pages: [%i]\n",freePages);
  enableIrq(0);
  return(0);
  }

  
